--    Copyright (C) 2004 by neuron                                          
--    aagaande@gmail.com                                            
--                                                                          
--    This program is free software; you can redistribute it and--or modify  
--    it under the terms of the GNU General Public License as published by  
--    the Free Software Foundation; either version 2 of the License, or     
--    (at your option) any later version.                                   
--                                                                          
--    This program is distributed in the hope that it will be useful,       
--    but WITHOUT ANY WARRANTY; without even the implied warranty of        
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
--    GNU General Public License for more details.                          
--                                                                          
--    You should have received a copy of the GNU General Public License     
--    along with this program; if not, write to the                         
--    Free Software Foundation, Inc.,                                       
--    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

-- This is for overriding blizzard quest functions

-- TODO:
--		Add quest levels for gossip frame and questlog frame

local quixote = AceLibrary("Quixote-1.0")

function nQuestLog:UpdateBlizzardQuestFrame()
	-- TODO make settings for this.
	-- Showing questlog stuff:
	self:Hook("QuestLog_Update",true)
	
	--Showing gossip frame levels:
	self:RegisterEvent("GOSSIP_SHOW","OnGossipShow")
	self:RegisterEvent("QUEST_GREETING","OnQuestGreeting")
end

function nQuestLog:OnGossipShow()
	local buttonOffset = 0
	local function showLevels(tList)
		for i=1,table.getn(tList) / 2 do
			local strQuestTitle = tList[(i * 2) - 1]
			local iQuestLevel = tList[i * 2]
			local button = getglobal("GossipTitleButton"..(i + buttonOffset));
			button:SetText("[" .. iQuestLevel .. "] " .. strQuestTitle)
		end
	end
	
	local tAvailable = { GetGossipAvailableQuests() }
	local tActive = { GetGossipActiveQuests() }
	showLevels(tAvailable)
	buttonOffset = table.getn(tAvailable)
	showLevels(tActive)
end

function nQuestLog:OnQuestGreeting()
	local buttonOffset = GetNumActiveQuests() or 0
	for i = 1, GetNumActiveQuests() do
		local iLevel = GetActiveLevel(i);
		local strTitle = GetActiveTitle(i);
		local button = getglobal("QuestTitleButton"..i);
		button:SetText(string.format('[%d] %s', iLevel, strTitle));
	end
	for i = 1, GetNumAvailableQuests() do
		local iLevel = GetAvailableLevel(i);
		local strTitle = GetAvailableTitle(i);
		local button = getglobal("QuestTitleButton"..i + buttonOffset);
		button:SetText(string.format('[%d] %s', iLevel, strTitle));
	end
end

function nQuestLog:QuestLog_Update()
	self.hooks.QuestLog_Update()
	local iEntries = GetNumQuestLogEntries()
	if (iEntries > 6) then iEntries = 6 end
	for i = 1, iEntries do
		local iQuestId = i + FauxScrollFrame_GetOffset(QuestLogListScrollFrame)
		local frame = getglobal("QuestLogTitle" .. i)
		local _, iLevel, _, _, isHeader = GetQuestLogTitle(iQuestId);
		if (not isHeader) then
			frame:SetText("[" .. iLevel .. "]" .. strsub(frame:GetText(),2))
		end
	end
end
